import java.io.IOException;
import java.io.StringWriter;
import java.util.*;
import java.util.Map.Entry;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.*;
import org.xml.sax.SAXException;
import com.sun.org.apache.xerces.internal.parsers.*;

public class HighScore {
	
	public Hashtable<String, String> scores;
	
	HighScore(String filename) {
		scores = new Hashtable<String, String>();
		read(filename);
	}
    
	public void write() throws ParserConfigurationException {
        DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
        Document doc = docBuilder.newDocument();
		
        Element root = doc.createElement("scores");
		doc.appendChild(root);
		
		Set<Entry<String, String>> noms = scores.entrySet();
		Iterator<Entry<String, String>> i = noms.iterator();
		
		while ( i.hasNext() ) {
			Entry<String, String> pair = i.next();
			Element nom = doc.createElement("nom");
			nom.setAttribute("nom", pair.getKey());
			nom.setAttribute("valeur", pair.getValue());
			root.appendChild(nom);
		}
		
		try {
			// Set up the output transformer
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.INDENT, "yes");

			// Print the DOM node

			StringWriter sw = new StringWriter();
			trans.transform(new DOMSource(doc), new StreamResult(sw));
			
			System.out.println(sw.toString());
		} catch (TransformerException e) {
			e.printStackTrace();
		}
	}
	
	public void read(String filename) {
		DOMParser parser = new DOMParser();
		try {
			parser.parse(filename);
		} catch (SAXException e) {
			System.out.println("Erreur du parseur : " + e.getMessage());
			System.exit(1);
		} catch (IOException e) {
			System.out.println("Erreur de fichier : " + e.getMessage());
			System.exit(1);	
		}
		Document racine = parser.getDocument();
		
		NodeList opts = racine.getElementsByTagName("score");
		
		if ( opts != null ){
			for (int i = 0 ; i < opts.getLength() ; i++) {
				String nom = ((Element) opts.item(i)).getAttribute("nom");
				String val = ((Element) opts.item(i)).getAttribute("valeur");
				scores.put(nom, val);
			}
		}
	}
}
