import java.io.IOException;
import java.util.*;
import org.w3c.dom.*;
import org.xml.sax.SAXException;
import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public class Options {
	
	public Hashtable<String, String> options;
	
	Options(String filename) {
		options = new Hashtable<String, String>();
		read_other(filename);
	}
	
	public void read(String filename) {
		DOMParser parser = new DOMParser();
		try {
			parser.parse(filename);
		} catch (SAXException e) {
			System.out.println("Erreur du parseur : " + e.getMessage());
			System.exit(1);
		} catch (IOException e) {
			System.out.println("Erreur de fichier : " + e.getMessage());
			System.exit(1);	
		}
		Document racine = parser.getDocument();
		
		NodeList opts = racine.getChildNodes().item(0).getChildNodes();
		
		if ( opts != null ){
			for (int i = 0 ; i < opts.getLength() ; i++) {
				int type = opts.item(i).getNodeType();
				if( type == Node.ELEMENT_NODE ) {
					String nom = opts.item(i).getAttributes().getNamedItem("nom").getNodeValue();
					String val = opts.item(i).getAttributes().getNamedItem("valeur").getNodeValue();
					options.put(nom, val);
				}
			}
		}
	}

	public void read_other(String filename) {
		DOMParser parser = new DOMParser();
		try {
			parser.parse(filename);
		} catch (SAXException e) {
			System.out.println("Erreur du parseur : " + e.getMessage());
			System.exit(1);
		} catch (IOException e) {
			System.out.println("Erreur de fichier : " + e.getMessage());
			System.exit(1);	
		}
		Document racine = parser.getDocument();
		
		NodeList opts = racine.getElementsByTagName("option");
		
		if ( opts != null ){
			for (int i = 0 ; i < opts.getLength() ; i++) {
				String nom = ((Element) opts.item(i)).getAttribute("nom");
				String val = ((Element) opts.item(i)).getAttribute("valeur");
				options.put(nom, val);
			}
		}
	}
}
