import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import org.w3c.dom.*;
import org.xml.sax.SAXException;
import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public class Test2 {

	public static void main(String[] args) {
		DOMParser parser = new DOMParser();
		try {
			parser.parse("test.xml");
		} catch (SAXException e) {
			System.out.println("Erreur du parseur : " + e.getMessage());
			System.exit(1);
		} catch (IOException e) {
			System.out.println("Erreur de fichier : " + e.getMessage());
			System.exit(1);
		}
		Document doc = parser.getDocument();
		traverse(doc);
		try {
			// Set up the output transformer
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.INDENT, "yes");

			// Print the DOM node

			StringWriter sw = new StringWriter();
			trans.transform(new DOMSource(doc), new StreamResult(sw));

			System.out.println(sw.toString());
		} catch (TransformerException e) {
			e.printStackTrace();
		}

	}

	private static void traverse(Node node) {

		NodeList children = node.getChildNodes();
		if (children != null)
			for (int i = 0; i < children.getLength(); i++) {
				if ((children.item(i).getNodeType() == Node.ELEMENT_NODE)
						&& (children.item(i).getNodeName().equals("titre"))) {
					node.removeChild(children.item(i));
				} else
					traverse(children.item(i));
			}
	}
}
